<?php
/*
Plugin Name: Ultimate CMS
Plugin URI: http://xydac.com/
Description: Ultimate CMS
Author: XYDAC
Author URI: http://xydac.com/
Version: 0.1 beta
License: GPL2
*/

//Define Constants
	if ( !defined( 'XYDAC_CMS_NAME' ) )define('XYDAC_CMS_NAME',"ultimate-cms");
	if ( !defined( 'XYDAC_CMS_USER_API_KEY' ) )define('XYDAC_CMS_USER_API_KEY',"xydac_cms_api_key");

	global $xydac_cms_fields;
//File includes
	require_once 'class-field-type.php';
	require_once 'class-xydac-ultimate-cms-core.php';
	require_once 'class-inflect.php';
	include 'class-xydac-export.php';
	include 'post-type/post-type.php';
	include 'page-type/page-type.php';
	include 'archiver/archiver.php';
	include 'taxonomy/taxonomy.php';
	
//Functions
	

	function xydac_cms_init()
	{
		$role = get_role("administrator");
        $role->add_cap("manage_xydac_cms");
		xydac_fieldtypes_init();
		wp_enqueue_script("jquery");
	}

	function xydac_cms_site_head()
	{
		
		echo '<link rel="stylesheet" type="text/css" media="all" href="'.get_bloginfo('wpurl').'/wp-content/plugins/'.XYDAC_CMS_NAME.'/css.php" />';
		echo '<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/'.XYDAC_CMS_NAME.'/script.php"></script>';
	}
	function xydac_cms_admin_head()
	{
		echo '<link rel="stylesheet" type="text/css" media="all" href="'.get_bloginfo('wpurl').'/wp-content/plugins/'.XYDAC_CMS_NAME.'/css.php?type=admin" />';
		echo '<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/'.XYDAC_CMS_NAME.'/script.php?type=admin"></script>';
	}

	function xydac_cms_admin_menu()
	{
		$xydac_main_menu = add_menu_page('Ultimate CMS', 'Ultimate CMS', 'manage_xydac_cms', 'xydac_ultimate_cms', 'xydac_cms_main1');
		$xydac_post_menu = add_submenu_page( 'xydac_ultimate_cms', 'Archive Manager', 'Archive Manager', 'manage_xydac_cms', 'xydac_ultimate_cms_archive', 'xydac_cms_archive');
		$xydac_post_menu = add_submenu_page( 'xydac_ultimate_cms', 'Post Type Manager', 'Post Type Manager', 'manage_xydac_cms', 'xydac_ultimate_cms_post_type', 'xydac_cms_post_type');
		$xydac_page_menu = add_submenu_page( 'xydac_ultimate_cms', 'Page Type Manager', 'Page Type Manager', 'manage_xydac_cms', 'xydac_ultimate_cms_page_type', 'xydac_cms_page_type');
		$xydac_tax_menu = add_submenu_page( 'xydac_ultimate_cms', 'Taxonomies Manager', 'Taxonomies Manager', 'manage_xydac_cms', 'xydac_ultimate_cms_taxonomies', 'xydac_cms_taxonomies');

	}
	function xydac_cms_main1(){
		echo "<h2>This Page is not Availaible in this version</h2>";
		echo "<p>Hi Everyone,<br>
		Well i haven't got time these days so was not able to work on this plugin. Am still working on it as you can see...<br/>
		This is a small preview for everyone out there...<br>
		You can help me focus on this project by sending me some donations if you can...:P
		</p>";
		xydac_show_donate_link();
		echo "<br/><h4><em>Addin Music to poetry</em></h4>";
	}
	function xydac_cms_build_active_field_types()
	{ 
	$cpts=array();
	$cpts['posttype'] = xydac_get_active_cpt();
	$cpts['pagetype'] = get_active_page_types();
	$cpts['taxtype'] = xydac_get_active_taxonomy();
	
	$xydac_active_field_types = array();
	if(is_array($cpts))
		foreach($cpts as $k=>$cpt)
			{
				foreach($cpt as $cp)
				{
					if('posttype'==$k)
						$fields = getCptFields($cp['name']);
					else if('pagetype'==$k)
						$fields = get_page_type_fields($cp['name']);
					else if('pagetype'==$k)
						$fields = get_taxonomy_fields($cp['name']);
					
					if(is_array($fields) && !empty($fields))
					foreach($fields as $field)
						{	
							if(!in_array($field['field_type'],$xydac_active_field_types))
								array_push($xydac_active_field_types,$field['field_type']);
						}
				}
			}
		
		update_option('xydac_active_field_types',$xydac_active_field_types);
		
	}
	
	function xydac_cms_cpt_field_convert()
	{ global $wpdb;
	$cpts = get_reg_cptName();
	if(is_array($cpts))
		foreach($cpts as $cpt)
			{
				$fields = getCptFields($cpt);

				if(is_array($fields) && !empty($fields))
				foreach($fields as $field)
					{	
						$metas = $wpdb->get_results("SELECT meta_id, meta_value FROM ".$wpdb->postmeta." WHERE meta_key ='".$field['field_name']."'");
						foreach($metas as $meta)
							{
								$meta->meta_value = maybe_unserialize($meta->meta_value);
								$r = false;
								if(is_array($meta->meta_value))
									{
									foreach($meta->meta_value as $k=>$v)
										if($k==$field['field_type'])
										{
											$wpdb->query("UPDATE ".$wpdb->postmeta." SET meta_value='".$v."' WHERE meta_id = ".$meta->meta_id);
										}
									}
							}
						if(!in_array($field['field_type'],$xydac_active_field_types))
							array_push($xydac_active_field_types,$field['field_type']);
					}
			}
			
		update_option('xydac_active_field_types',$xydac_active_field_types);
		update_option('xydac_cms_ver','1.0');
	}
	if ( !function_exists( 'xydac_cms_activate' ) ) {function xydac_cms_activate()
	{
	global $wpdb;
	if (function_exists('is_multisite') && is_multisite()) {
			// check if it is a network activation - if so, run the activation function for each blog id
			if (isset($_GET['networkwide']) && ($_GET['networkwide'] == 1)) {
						$old_blog = $wpdb->blogid;
				// Get all blog ids
				$blogids = $wpdb->get_col($wpdb->prepare("SELECT blog_id FROM $wpdb->blogs"));
				foreach ($blogids as $blog_id) {
					switch_to_blog($blog_id);
					xydac_cms_cpt_field_convert();
					do_action('xydac_cms_activate');
				}
				switch_to_blog($old_blog);
				return;
			}	
		} 
		xydac_cms_cpt_field_convert();	
		do_action('xydac_cms_activate');
	}}
	function is_xydac_ucms_pro(){
	$k = get_option(XYDAC_CMS_USER_API_KEY);
	if(empty($k))
		return false;
	else
		return true;
	}
	function xydac_show_donate_link($showimage=true){
		echo '
		<p class="xydacdonation">
		<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=nikhilseth1989%40gmail%2ecom&item_name=WordPress%20Plugin%20(Ultimate%20CMS)&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8">
		';
		if($showimage)
			echo '<img src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif"/>';
		echo 'You might want to help building this plugin with some Donations. Please Click here to Donate';
		if($showimage)
			echo '<img src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif"/>';
		echo'
		</a>
		</p>
			';
	}
//Actions
add_action('init','xydac_cms_init');
add_action('admin_menu', 'xydac_cms_admin_menu');
add_action('admin_head', 'xydac_cms_admin_head');
add_action('wp_head', 'xydac_cms_site_head');
register_activation_hook( __FILE__, 'xydac_cms_activate' );

?>